//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
unsigned int stepnumber = 1;               //   
unsigned int stepsleft = 0;                //  
unsigned int oldstate1 = 1;                //   1
unsigned int oldstate2 = 1;                //   2
unsigned int oldstate3 = 1;                //   3
unsigned int menuitem = 1;                 //    
unsigned int replays = 1;                  //   
char txt[7];                               //   
unsigned int programtype = 1;              //   
unsigned int steps = 0;                    //   
unsigned int a_pulses = 0;                 //    
unsigned int b_pulses = 0;                 //    
unsigned int z_pulses = 0;                 //   z-
unsigned int a_out = 0;                    //  .  
unsigned int b_out = 0;                    //  .  
unsigned int intro = 100;                  //   
unsigned int Z_rounds = 0;                 //    Z-
bit aold;                                  //   
bit bold;                                  //   
unsigned int m;                            //  


//  

char device[7] = "DEVICE";
char ready[6] = "READY";
char prog[8] = "PROGRAM";
char one[4] = "ONE";
char two[4] = "TWO";
char run1[6] = "1 RUN";
char run2[6] = "2 RUN";
char repl[8] = "REPLAYS";

//   

   // Lcd pinout settings
   sbit LCD_RS at RE0_bit;
   sbit LCD_EN at RE2_bit;
   sbit LCD_D7 at RC7_bit;
   sbit LCD_D6 at RC6_bit;
   sbit LCD_D5 at RC5_bit;
   sbit LCD_D4 at RC4_bit;

   // Pin direction
   sbit LCD_RS_Direction at TRISE0_bit;
   sbit LCD_EN_Direction at TRISE2_bit;
   sbit LCD_D7_Direction at TRISC7_bit;
   sbit LCD_D6_Direction at TRISC6_bit;
   sbit LCD_D5_Direction at TRISC5_bit;
   sbit LCD_D4_Direction at TRISC4_bit;

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                      
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void interrupt(){
//  
       INTCON.GIE = 0;                                                 //  
       //   INT
       if (INTCON.INTF == 1) z_pulses++;                               //   Z 
       if ((INTCON.INTF == 1)&&(z_pulses>0)) stepsleft--;                //   
       //  
       else{
            switch (programtype){
            case 1: {                                                  //  1
                   if (PORTB.B5 > aold) a_pulses++;
                   if (PORTB.B4 > bold) b_pulses++;
             break;}
            case 2: {                                                  //  2
                   if ((PORTB.B5 > aold)&&(z_pulses > 0)) a_pulses++;
                   if ((PORTB.B4 > bold)&&(z_pulses > 0)) b_pulses++;
             break;}
            }
           if (PORTB.B5 != aold) aold = PORTB.B5;
           if (PORTB.B4 != bold) bold = PORTB.B4;
           }
       m = PORTB;
       INTCON = 0x98;                                                  //  

}
void microstep(){
//      
          while(stepsleft>0){
               switch (stepnumber) {
               case 1: PORTD = 0b10010000;   break;
               case 2: PORTD = 0b00010000;   break;
               case 3: PORTD = 0b00110000;   break;
               case 4: PORTD = 0b00100000;   break;
               case 5: PORTD = 0b01100000;   break;
               case 6: PORTD = 0b01000000;   break;
               case 7: PORTD = 0b11000000;   break;
               case 8: PORTD = 0b10000000;   break;
               }
               stepnumber++;
               if (stepnumber > 8) stepnumber = 1;
               if (programtype == 1) stepsleft--;

               intro--;                                   // 100     -  
               if (intro==0) INTCON = 0x98;               //     
               Delay_ms (1);                              //   
               }
               }
void program(){
//   
   Lcd_Cmd(_LCD_CLEAR);                                   //  
   Lcd_Out(1, 1, prog);                                   // Print text on LCD
   a_pulses = 0;                                          //   
   b_pulses = 0;                                          //   
   z_pulses = 0;                                          //   
   stepsleft = 0;
   switch (programtype){                                  //      
               case 1: Lcd_Out(2, 1, run1);               // Print text on LCD
                       stepsleft = replays * 1920 + 100;      //   (n*1920 + (100))
                       //stepsleft = steps;
                       break;
               case 2: Lcd_Out(2, 1, run2);               // Print text on LCD
                       stepsleft = replays + 1;           //   (+1   )
                       //stepsleft = steps;
                       break;
               }

   microstep();                                            //   
   
   a_out = a_pulses / replays;                            //    /
   b_out = b_pulses / replays;                            //    /
   INTCON = 0x00;                                         //  
   intro = 100;                                           //    
   Lcd_Cmd(_LCD_CLEAR);
   IntToStr(b_out, txt);
   Lcd_Out(2, 1, txt);                                    // Print text on LCD
   Lcd_Out(2, 1, "B:");                                   // Print text on LCD
   IntToStr(a_out, txt);
   Lcd_Out(1, 1, txt);                                    // Print text on LCD
   Lcd_Out(1, 1, "A:");                                   // Print text on LCD
   PORTD = 0x00;                                          //  
   menuitem = 5;                                          //    
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void main() {
//******************************************************************************
// 
//******************************************************************************
  TRISA = 0xff;                  // PORTA
  TRISB = 0b00111111;            // PORTB    (0(INT),4,5)   (1-3)
  TRISC = 0x00;                  // PORTC   LCD
  TRISD = 0x00;                  // PORTD    (4-7)
  TRISE = 0x00;                  // PORTE   LCD
  ADCON1 = 0x06;                 //  - 
  PORTB = 0x00;                  // 
  PORTD = 0x00;                  //  
  PORTC = 0x00;                  //  
  PORTE = 0x00;                  //  
  
  //  
  
  INTCON = 0x00;                 //  
  OPTION_REG.INTEDG = 0;         //  INT  
  PIE1 = 0x00;                   //
  PIR1 = 0x00;                   //
  PIE2 = 0x00;                   //
  PIR2 = 0x00;                   //
  m = PORTB;                     //    


  Lcd_Init();                    //  
  Lcd_Cmd(_LCD_CURSOR_OFF);      //  
  Lcd_Cmd(_LCD_CLEAR);           //  
  Lcd_Out(1, 1, "WAIT...");      // Print text on LCD
  Delay_ms(1000);                //  1 

  menuitem = 1;                  //    
  Lcd_Cmd(_LCD_CLEAR);           //  
  Lcd_Out(1, 1, device);         // Print text on LCD
  Lcd_Out(2, 1, ready);          // Print text on LCD

//  

//*****************************************************************************
//    
//*****************************************************************************
    while(1){
//  

  if (oldstate1 && Button(&PORTA, 0, 10, 0)) {
     oldstate1 = 0;
    //     1      

     switch (menuitem){
     case 1 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, prog);                // Print text on LCD
              Lcd_Out(2, 1, one);                 // Print text on LCD
              programtype = 1;                    //   1
              menuitem = 2;                       //      (2-3)
              break;
     case 2 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, prog);                // Print text on LCD
              Lcd_Out(2, 1, two);                 // Print text on LCD
              programtype = 2;                    //   2
              menuitem = 3;
              break;
     case 3 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, prog);                // Print text on LCD
              Lcd_Out(2, 1, one);                 // Print text on LCD
              programtype = 1;                    //   1
              menuitem = 2;
              break;
     case 4 : replays = replays++;                //   
              if (replays > 10) replays = 10;
              IntToStr(replays, txt);
              Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, repl);                // Print text on LCD
              Lcd_Out(2, 1, txt);                 // Print text on LCD
              break;
     case 5 :  Lcd_Cmd(_LCD_CLEAR);
               Lcd_Out(1, 1, device);             // Print text on LCD
               Lcd_Out(2, 1, ready);              // Print text on LCD
               menuitem = 1; break;
     }
  }
  if (!oldstate1 && Button(&PORTA, 0, 10, 1)) oldstate1 = 1;

  if (oldstate2 && Button(&PORTA, 1, 10, 0)) {
    oldstate2 = 0;
    //     2      

    switch (menuitem){
     case 1 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, prog);                // Print text on LCD
              Lcd_Out(2, 1, one);                 // Print text on LCD
              programtype = 1;                    //   1
              menuitem = 2;                       //      (2-3)
              break;
     case 2 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, prog);                // Print text on LCD
              Lcd_Out(2, 1, two);                 // Print text on LCD
              programtype = 2;                    //   2
              menuitem = 3;
              break;
     case 3 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, prog);                // Print text on LCD
              Lcd_Out(2, 1, one);                 // Print text on LCD
              programtype = 1;                    //   1
              menuitem = 2;
              break;
     case 4 : replays = replays--;                //   
              if (replays < 1) replays = 1;
              IntToStr(replays, txt);
              Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, repl);                // Print text on LCD
              Lcd_Out(2, 1, txt);                 // Print text on LCD
              break;
     case 5 :  Lcd_Cmd(_LCD_CLEAR);
               Lcd_Out(1, 1, device);             // Print text on LCD
               Lcd_Out(2, 1, ready);              // Print text on LCD
               menuitem = 1; break;

     }
  }
  if (!oldstate2 && Button(&PORTA, 1, 10, 1)) oldstate2 = 1;

  if (oldstate3 && Button(&PORTA, 2, 10, 0)) {
    oldstate3 = 0;
    //     3      
       
    switch (menuitem){
     case 1 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, prog);                // Print text on LCD
              Lcd_Out(2, 1, one);                 // Print text on LCD
              programtype = 1;                    //   1
              menuitem = 2;                       //      (2-3)
              break;
     case 2 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, repl);                // Print text on LCD
              IntToStr(replays, txt);
              Lcd_Out(2, 1, txt);                 // Print text on LCD
              menuitem = 4;
              break;
     case 3 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, repl);                // Print text on LCD
              IntToStr(replays, txt);
              Lcd_Out(2, 1, txt);                 // Print text on LCD
              menuitem = 4;
              break;
     case 4 : program();                          //  
              break;
     case 5 : Lcd_Cmd(_LCD_CLEAR);
              Lcd_Out(1, 1, device);              // Print text on LCD
              Lcd_Out(2, 1, ready);               // Print text on LCD
              menuitem = 1;
              programtype = 1;
              break;

     }
}
  if (!oldstate3 && Button(&PORTA, 2, 10, 1)) oldstate3 = 1;



  } //    

}