#line 1 "D:/works/PIC/STEP_C/steptester.c"



unsigned int stepnumber = 1;
unsigned int stepsleft = 0;
unsigned int oldstate1 = 1;
unsigned int oldstate2 = 1;
unsigned int oldstate3 = 1;
unsigned int menuitem = 1;
unsigned int replays = 1;
char txt[7];
unsigned int programtype = 1;
unsigned int steps = 0;
unsigned int a_pulses = 0;
unsigned int b_pulses = 0;
unsigned int z_pulses = 0;
unsigned int a_out = 0;
unsigned int b_out = 0;
unsigned int intro = 100;
unsigned int Z_rounds = 0;
bit aold;
bit bold;
unsigned int m;




char device[7] = "DEVICE";
char ready[6] = "READY";
char prog[8] = "PROGRAM";
char one[4] = "ONE";
char two[4] = "TWO";
char run1[6] = "1 RUN";
char run2[6] = "2 RUN";
char repl[8] = "REPLAYS";




 sbit LCD_RS at RE0_bit;
 sbit LCD_EN at RE2_bit;
 sbit LCD_D7 at RC7_bit;
 sbit LCD_D6 at RC6_bit;
 sbit LCD_D5 at RC5_bit;
 sbit LCD_D4 at RC4_bit;


 sbit LCD_RS_Direction at TRISE0_bit;
 sbit LCD_EN_Direction at TRISE2_bit;
 sbit LCD_D7_Direction at TRISC7_bit;
 sbit LCD_D6_Direction at TRISC6_bit;
 sbit LCD_D5_Direction at TRISC5_bit;
 sbit LCD_D4_Direction at TRISC4_bit;





void interrupt(){

 INTCON.GIE = 0;

 if (INTCON.INTF == 1) z_pulses++;
 if ((INTCON.INTF == 1)&&(z_pulses>0)) stepsleft--;

 else{
 switch (programtype){
 case 1: {
 if (PORTB.B5 > aold) a_pulses++;
 if (PORTB.B4 > bold) b_pulses++;
 break;}
 case 2: {
 if ((PORTB.B5 > aold)&&(z_pulses > 0)) a_pulses++;
 if ((PORTB.B4 > bold)&&(z_pulses > 0)) b_pulses++;
 break;}
 }
 if (PORTB.B5 != aold) aold = PORTB.B5;
 if (PORTB.B4 != bold) bold = PORTB.B4;
 }
 m = PORTB;
 INTCON = 0x98;

}
void microstep(){

 while(stepsleft>0){
 switch (stepnumber) {
 case 1: PORTD = 0b10010000; break;
 case 2: PORTD = 0b00010000; break;
 case 3: PORTD = 0b00110000; break;
 case 4: PORTD = 0b00100000; break;
 case 5: PORTD = 0b01100000; break;
 case 6: PORTD = 0b01000000; break;
 case 7: PORTD = 0b11000000; break;
 case 8: PORTD = 0b10000000; break;
 }
 stepnumber++;
 if (stepnumber > 8) stepnumber = 1;
 if (programtype == 1) stepsleft--;

 intro--;
 if (intro==0) INTCON = 0x98;
 Delay_ms (1);
 }
 }
void program(){

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, prog);
 a_pulses = 0;
 b_pulses = 0;
 z_pulses = 0;
 stepsleft = 0;
 switch (programtype){
 case 1: Lcd_Out(2, 1, run1);
 stepsleft = replays * 1920 + 100;

 break;
 case 2: Lcd_Out(2, 1, run2);
 stepsleft = replays + 1;

 break;
 }

 microstep();

 a_out = a_pulses / replays;
 b_out = b_pulses / replays;
 INTCON = 0x00;
 intro = 100;
 Lcd_Cmd(_LCD_CLEAR);
 IntToStr(b_out, txt);
 Lcd_Out(2, 1, txt);
 Lcd_Out(2, 1, "B:");
 IntToStr(a_out, txt);
 Lcd_Out(1, 1, txt);
 Lcd_Out(1, 1, "A:");
 PORTD = 0x00;
 menuitem = 5;
}



void main() {



 TRISA = 0xff;
 TRISB = 0b00111111;
 TRISC = 0x00;
 TRISD = 0x00;
 TRISE = 0x00;
 ADCON1 = 0x06;
 PORTB = 0x00;
 PORTD = 0x00;
 PORTC = 0x00;
 PORTE = 0x00;



 INTCON = 0x00;
 OPTION_REG.INTEDG = 0;
 PIE1 = 0x00;
 PIR1 = 0x00;
 PIE2 = 0x00;
 PIR2 = 0x00;
 m = PORTB;


 Lcd_Init();
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, "WAIT...");
 Delay_ms(1000);

 menuitem = 1;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, device);
 Lcd_Out(2, 1, ready);






 while(1){


 if (oldstate1 && Button(&PORTA, 0, 10, 0)) {
 oldstate1 = 0;


 switch (menuitem){
 case 1 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, prog);
 Lcd_Out(2, 1, one);
 programtype = 1;
 menuitem = 2;
 break;
 case 2 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, prog);
 Lcd_Out(2, 1, two);
 programtype = 2;
 menuitem = 3;
 break;
 case 3 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, prog);
 Lcd_Out(2, 1, one);
 programtype = 1;
 menuitem = 2;
 break;
 case 4 : replays = replays++;
 if (replays > 10) replays = 10;
 IntToStr(replays, txt);
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, repl);
 Lcd_Out(2, 1, txt);
 break;
 case 5 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, device);
 Lcd_Out(2, 1, ready);
 menuitem = 1; break;
 }
 }
 if (!oldstate1 && Button(&PORTA, 0, 10, 1)) oldstate1 = 1;

 if (oldstate2 && Button(&PORTA, 1, 10, 0)) {
 oldstate2 = 0;


 switch (menuitem){
 case 1 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, prog);
 Lcd_Out(2, 1, one);
 programtype = 1;
 menuitem = 2;
 break;
 case 2 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, prog);
 Lcd_Out(2, 1, two);
 programtype = 2;
 menuitem = 3;
 break;
 case 3 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, prog);
 Lcd_Out(2, 1, one);
 programtype = 1;
 menuitem = 2;
 break;
 case 4 : replays = replays--;
 if (replays < 1) replays = 1;
 IntToStr(replays, txt);
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, repl);
 Lcd_Out(2, 1, txt);
 break;
 case 5 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, device);
 Lcd_Out(2, 1, ready);
 menuitem = 1; break;

 }
 }
 if (!oldstate2 && Button(&PORTA, 1, 10, 1)) oldstate2 = 1;

 if (oldstate3 && Button(&PORTA, 2, 10, 0)) {
 oldstate3 = 0;


 switch (menuitem){
 case 1 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, prog);
 Lcd_Out(2, 1, one);
 programtype = 1;
 menuitem = 2;
 break;
 case 2 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, repl);
 IntToStr(replays, txt);
 Lcd_Out(2, 1, txt);
 menuitem = 4;
 break;
 case 3 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, repl);
 IntToStr(replays, txt);
 Lcd_Out(2, 1, txt);
 menuitem = 4;
 break;
 case 4 : program();
 break;
 case 5 : Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, device);
 Lcd_Out(2, 1, ready);
 menuitem = 1;
 programtype = 1;
 break;

 }
}
 if (!oldstate3 && Button(&PORTA, 2, 10, 1)) oldstate3 = 1;



 }

}
